
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Swift游戏开发之俄罗斯方块：No.8 游戏规则 / iVAN</title>

    <meta name="description" content="Swift游戏开发之俄罗斯方块：No.8 游戏规则 每个游戏都有它自己的规则,我们的俄罗斯方块的规则很明显,shape落到最底端时就停止下落,然后下一个shape开始往下落:当任一一个点挡住下落的shape时,整个shape就认为是已经到底了:当一行充满所有blocks时,这行消除,然后所有的往下落一行等等等等. 那么我们现在就开始制定我们的游戏规则,本节过后,我们的程序运行起来是这样子的: 我们首先从自定义的协议(protocol)开始,之前我们已经接触过两个swift自带的协议,hashable和printable.我们首先在swiftris">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Swift游戏开发之俄罗斯方块：No.8 游戏规则</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>每个游戏都有它自己的规则，我们的俄罗斯方块的规则很明显，shape落到最底端时就停止下落，然后下一个shape开始往下落；当任一一个点挡住下落的shape时，整个shape就认为是已经到底了；当一行充满所有blocks时，这行消除，然后所有的往下落一行等等等等。</p>
<p>那么我们现在就开始制定我们的游戏规则，本节过后，我们的程序运行起来是这样子的：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvYy1ib29rcy5zMy5hbWF6b25hd3MuY29tL3N3aWZ0cmlzLzA5LWl0cy1vbmx5LWxvZ2ljYWwtZmluYWwuZ2lm.jpg"></p>
<p>我们首先从自定义的协议（<strong>protocol</strong>）开始，之前我们已经接触过两个swift自带的协议，<strong>hashable</strong>和<strong>printable</strong>。我们首先在swiftris类中添加我们自己的protocol</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMDIxMzM3OTc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>我们的程序将以<strong>试错法（trial-and-error）</strong>作为基本的原则进行，我们的用户交互界面<strong>GameViewController</strong>询问<strong>swiftris</strong>去向左向右向下移动，如果这条指令是合法的，我们就执行。</p>
<p>那什么时候“不合法”呢？我们来定义不合法的情况。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMDI3NTMzMTU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMDI4MDU2Njk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>这里我们在<strong>#2</strong>中新建了一个函数用来判断shape是否处于不合法的地方，因为我们采用<strong>trial-and-error</strong>方法来测试是否处于合法位置，所以，我们的shape可能会处于各种奇怪的地方，没有关系。</p>
<p>接下来我们添加一些函数，用来旋转，移动我们的shape</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMTU3Mzk2MTQ/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMTU3NDgwNjk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><strong>#1</strong>中我们分别添加了两个函数让shape可以顺时针和逆时针的旋转，接下来我们添加了可以使shape左右上下移动的函数</p>
<p>接下来，让我们真正让这些函数发挥作用吧：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjAxMTMxNzg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjAxNTU3MzU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjAyMTIwOTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><strong>#1 dropshape</strong>函数中，我们每次将shape往下移动一行，如果它没有处于非法的位置，就循环执行下去，知道它处于非法的位置，因为它已经处于非法的位置了，所以我们需要把它复原到最后一个合法的位置，所以我们需要把它往上移动一行。</p>
<p><strong>#2 </strong><br />
我们定义了每次tick都会被调用的函数，不用担心没有见到的settle函数，我们稍后会来完善它</p>
<p><strong>#3</strong> 我们可以让我们的shape在下落的过程中旋转</p>
<p>让我们来修复现在存在的error</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjEwMDU2ODU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><strong>#1</strong>中的settleShape函数会在shape无法再往下落的时候调用，我们把当前shape中的所有block都写入到blockArray里面，然后告诉程序，这个shape已经成功着陆了，不管它是真的着陆还是降落在别的shape头上，<strong>#2</strong>中的函数正是完成这样的检测；</p>
<p>同时fallingshape设置成nil，这样swiftris就会开始新的fallingshape。</p>
<p><strong>得分机制</strong></p>
<p>我们应该还记得，玩游戏大部分都有得分的，让我们来完善得分机制吧：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjE1Mjk0ODA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjE1NTcwNzY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjE2MDk4OTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>我们需要一组变量 <strong>score</strong>和<strong>level</strong>来表示得分和关卡数 </p>
<p>当我们移除掉一整行的时候，我们就得分了，整个游戏就是依靠这样来得分的，对吧。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjE4MzM1Mjg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjE4NDY5NzU/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>这是一段很长很长的代码，但是里面应该没有什么特别难以理解的内容，整个逻辑看起来也很清楚。返回两个数组，<strong>linesRemoved</strong>和<strong>fallenBlocks</strong></p>
<p>好了，我们已经走完了好长的一段，休息一下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvYmxvYy1ib29rcy5zMy5hbWF6b25hd3MuY29tL3N3aWZ0cmlzLzA5LWl0cy1vbmx5LWxvZ2ljYWwtcHVwcHkuZ2lm.jpg"></p>
<p>接下来还有好长的一段路要走。。。。。。。。。。。。。。。</p>
<p>swiftris即将完成了，我们还需要一个函数允许用户一次性将所有的block都移除出去</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjIzMzM2ODk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>是时候将我们之前自定义的协议和<strong>GameViewController</strong>联系起来了</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjI2Mjk5MDY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjI2MTIxMDc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjI2NDM1MjY/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTAyMDQyMjI2NTg4MTM/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2ZFRBeE1URTFOakF4TWc9PS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>好了，运行一下你的程序，看看是不是想象的样子呢？</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-19 08:53:41</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Swift游戏开发之俄罗斯方块：No.8 游戏规则的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwKv3vz.html" rel="bookmark">Swift游戏开发之俄罗斯方块：No&period;0</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				花了一周时间,按照Swift的开发教程,各种查阅资料,各种google,总算把俄罗斯方块游戏写完了,也想写个系列教学blog:因为虽然看着教程不长,但是对于从零学Swift的我,中间还是遇到了很多困难,好多bug不知道是怎么出来的,都是经过很纠结的过程才一一克服掉的,所以,这篇中文版的系列教学,也算是个为想学swift而又无从下手的童鞋们图个方便吧. 先上一个最终版本,基本效果就是这样,添加了动画效果和音效等等,其实还有很多事情可以做,只要照着这系列的blog进行下去,相信大家最终都创造出有着自			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z4YB6Pb.html" rel="bookmark">Swift游戏开发之俄罗斯方块：No&period;1 建立你的第一个Swift游戏工程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文地址:https://www.bloc.io/tutorials/swiftris-build-your-first-ios-game-with-swift#!/chapters/677 好了,我们正式开始我们的swift游戏开发! 首先,需要新建一个工程,熟悉iOS开发的童鞋应该对这个步骤不会陌生.我们还是一步一步来吧: 这里有两种途径建立全新的工程,你可以:  如果你的Mac没有运行Xcode,请打开它,然后在欢迎页面点击Create a new Xcode project 这里我还是要			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr1rwM.html" rel="bookmark">【ANDROID游戏开发十三】（保存游戏数据 &lbrack;下文&rsqb;）详解SQLITE存储方式&comma;并把SQLITE的数据库文件存储在SD卡中！！！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/329.html ----------------------- 『很多童鞋说我的代码运行后,点击home或者back后会程序异常,如果你也这样遇到过,那么你肯定没有仔细读完Himi的博文,第十九篇Himi专门写了关于这些错误的原因和解决方法,这里我在博客都补充说明下,省的童鞋们总疑惑这一块:请点击下面联系进入阅读:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQ3ndp.html" rel="bookmark">【IOS-COCOS2D游戏开发之一】搭建COCOS2D游戏引擎环境HELLOWORLD！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/iphone-cocos2d/415.html 最近几天仔细了解了iOS游戏开发引擎,常用的cocos2d,Unity引擎,那么Unity是非免费的,而cocos2d则是免费开源的: 最后促使我选择cocos2d的原因有两点: 1.最重要的原因是它对应的开发工具,尤其是 &quot;ParticleDesigner&quot;,粒子系统编辑器,非常的喜			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My3Ny5z.html" rel="bookmark">【IOS-COCOS2D游戏开发之十九】游戏数据存储的四种常用方式NSKEYEDARCHIVER&sol;NSUSERDEFAULTS&sol;WRITE写入&sol;SQLITE3</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/iphone-cocos2d/513.html OK,今天Himi介绍游戏存储这一块,在Android游戏开发中Himi介绍了好几种保存的方式和形式,那么在iOS中也有几种方式,一般常用的有以下四种形式:   1.  NSKeyedArchiver(加密形式)        2.  NSUserDefaults        3.  Writ			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQB0VQM.html" rel="bookmark">【ANDROID游戏开发之二】剖析游戏开发用VIEW还是SURFACEVIEW ？！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/295.html ----------------------- 『很多童鞋说我的代码运行后,点击home或者back后会程序异常,如果你也这样遇到过,那么你肯定没有仔细读完Himi的博文,第十九篇Himi专门写了关于这些错误的原因和解决方法,这里我在博客都补充说明下,省的童鞋们总疑惑这一块:请点击下面联系进入阅读:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M12Zw5p.html" rel="bookmark">【ANDROID游戏开发二十七】讲解游戏开发与项目下的HDPI 、MDPI与LDPI资源文件夹以及游戏高清版本的设置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/android-game/389.html 今天一个开发者问到我为什么游戏开发要删除项目下的hdpi.mdpi和ldpi文件夹:下面详细给大家解答一下: 首先童鞋们如果看过我写的&lt;[Android游戏开发二十一]Android os设备谎言分辨率的解决方案!&gt;这一节的话都应该知道Android从1.6和更高,Google为了方便开发者对于各			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Gw0Ap.html" rel="bookmark">网页游戏开发入门教程二（游戏模式&plus;系统）&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.游戏模式目前webgame游戏模式大体上可以分为以下四类:1.玩家拥有一个城市,不断的升级城市内建筑,建筑可以自动获得物资,可以生产军队,军队之间进行对比数值的战斗.这里我简单的称为Ogame模式. 比较优秀的代表:战神世界II,Travian,Ogame,武林三国,纵横天下,领主online,乱舞春秋,热血三国,方便面三国等等.这是一个比较成熟的模式, 但正因为成熟.因此,玩家接触到这类游戏比较的多,除非你能超过这些优秀的代表,否则就只是简单的重复开发. 对玩家来说:优点:Ogame模式模			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlAVyNp.html" rel="bookmark">【IOS-COCOS2D游戏开发之二】COCOS2D 游戏开发资源贴（教程以及源码）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本站文章均为 李华明Himi 原创,转载务必在明显处注明:  转载自[黑米GameDev街区] 原文链接: http://www.himigame.com/iphone-cocos2d/420.html     这两天抽出一些时间学习cocos2d,发现资料N多,而且讲解的相当的全面:那么这段时间我也处于不断的学习中,当然好东西不私藏,这里我把比较经典的一个iOS游戏开发书籍给出,当然很多童鞋,我想都有了,那么就当是照顾没有的童鞋啦,下次发帖的时候,就应该是自己抽时间做个游戏出来后的时候,那么届			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvgAWM.html" rel="bookmark">Swift游戏开发之俄罗斯方块：No&period;2 准备工作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				如果你已经成功建好了工程,运行之后你会发现是个小飞机的程序,如果我没记错的: 这个程序是spin-the-bottle:Space Edition,但是可惜的是,我们并不需要这些东西,我们需要一个干净的模板,所以,我们需要首先清理下战场,然后把我们需要用到的一些资源放进来. 打开项目导航栏,如下图中圆圈内的图标,或者点击⌘ + 1: 右键点击GameScene.sks,选择delete 当系统询问的时候,选择move to trash 接下来点击image.xcassets,然后删除spaces			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5W1Db.html" rel="bookmark" class="title">开源领域常用的许可协议和它们之间的区别</a>
					<div>
						越来越多的开发者与设计者希望将自己的产品开源,以便其他人可以在他们的代码基础上做更多事,开源社区也因此充满生机.在我们所能想到的应用领域,都有开源软件存在(象 WordPress,Drupal 这些开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMR9oqb.html" rel="bookmark" class="title">IIS服务器组建一览&lpar;6&rpar;</a>
					<div>
						iis|服务器 如果你嫌互联网上的那些免费邮件发送邮件的速度过慢的话,你或许可以考虑用IIS来建立一个本地的SMTP服务器.不管你是直接连入互联网还是通过局域网接入,不管你是有静态的IP地址还是用动态 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJ2D4z.html" rel="bookmark" class="title">谈谈JAVA程序的反编译</a>
					<div>
						编译|程序   谈谈JAVA程序的反编译  如今JAVA语言在全世界范围正如火如荼般的流行,它广范地应用在INTERNET的数据库.多媒体.CGI.及动态网页的制作方面.1999年在美国对JAVA程序 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6VoXM.html" rel="bookmark" class="title">Photoshop文字特效教程&colon;带火苗的线条叠加字</a>
					<div>
						本教程文字制作比较简单,只需要找出文字边缘的线条,然后用图层叠加等来做出文字的效果.局部可以蒙版等来控制线条的范围. 最终效果 1.新建一个800 * 600像素的文档.背景填充黑色,选择文字工具,打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qzDGGrp.html" rel="bookmark" class="title">ASP&period;net在gridview中删除数据时同时更新xml文件</a>
					<div>
						asp.net|xml|数据 为了减少对数据库的访问,前台页面通常只对xml文件进行读取,但是更新数据库的时候需要同时更新xml文件,添加好办,但是删除的时候呢,下面的程序在gridview中删除数据 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/jbE3e3p.html" rel="bookmark" class="title">帮助新人站长树立对于百度的正确认知</a>
					<div>
						沙予本人做站也有几年时间了,在这几年的时间里虽然也没有混成什么成就,不过好在结识了不少的站长朋友,因此对于一些不管是老站长,还是新站长的情况以及网站的优化认知都有一定的了解,而且最近沙予也是碰到了好几 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPw3RM.html" rel="bookmark" class="title">使用ANTLR进行命令行参数解析</a>
					<div>
						关于命令行参数的解析没有特定的规则,目前比较流行的有unix风格和微软风格.其实除了unix风格 的比较一致外,微软自己提供的命令行参数解析就有很多种风格.在.net平台下的main函数中,仅仅把参  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jmPZb.html" rel="bookmark" class="title">可牛多图叠加功能合成美女壁纸</a>
					<div>
						苏州第一美女张馨予现在可说是内地最红的美女,她是中国第一国足宝贝,她是&quot;魔王&quot;刘谦最美的&quot;谦女郎&quot;,她是在线游戏&lt;穿越火线&gt;的代言人, 她是&lt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLO3EWM.html" rel="bookmark" class="title">怎么批量导出Word文档中所有图片</a>
					<div>
						  怎么批量导出Word文档中所有图片          1.打开要导出图片的Word文档,单击&quot;文件&quot;按钮,选择&quot;另存为&quot;,然后在计算机中选择一个存放位置,以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M62o2LM.html" rel="bookmark" class="title">Photoshop绘制哆啦A梦图标</a>
					<div>
						  Photoshop绘制哆啦A梦图标           最终效果 一.知识点提炼 二.教程部分 分类: PS入门教程 ps图标制作教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jQAPb.html" rel="bookmark" class="title">纯CSS实现的鼠标经过文本时提示的信息</a>
					<div>
						&lt;a class=&quot;tooltips&quot; href=&quot;#tooltips&quot;&gt;这就是Tooltips&lt;span&gt;正是你见到的,这些附加的说明 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKB1Ap.html" rel="bookmark" class="title">PPT如何克隆设定效果</a>
					<div>
						  幻灯片制作过程中免不了一些重复的步骤,遇到此类问题时,你是如何解决的呢?其实啊,工具还是蛮重要的,一把&quot;刷子&quot;和一块&quot;板子&quot;,对提高制作效率帮助很大. 善用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZO5Kkb.html" rel="bookmark" class="title">jQuery实现给页面换肤的方法</a>
					<div>
						  本文实例讲述了jQuery给页面换肤的方法.分享给大家供大家参考.具体分析如下: 给页面换肤的效果有不少同学做过,今天在逛blog时也发现一段使用jQuery换肤的代码,贴上与大家分享一下: ?  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKZo8p.html" rel="bookmark" class="title">腾达PR204动态IP连接上网设置教程</a>
					<div>
						  第一步:连接好线路 直接将入户的网线(没有猫的用户)或者猫出来的网线(有猫的用户 )接在路由器的WAN口,再找一根短网线,一头接电脑,一头接路由器LAN1/LAN2/LAN3任意接口,接线方式如下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvG4eVp.html" rel="bookmark" class="title">压缩卷只能压缩一半怎么办</a>
					<div>
						  预装Windows系统的机器,在安装了其他第三方软件,或者做过系统更新之后,再使用压缩卷分区,只能压缩差不多一半空间出来,再压缩就没有可用空间,但是C盘还是很大. 原因分析:可能是安装了软件或者是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEKa4z.html" rel="bookmark" class="title">互联网第一季成绩喜人 建站主机优势出击</a>
					<div>
						中介交易 SEO诊断 淘宝客 云主机 技术大厅 2010年是丰收的一年,第一季度互联网各行业都取得了喜人的成绩,电子商务市场整体交易额规模破万亿,第三方支付总额达到5550.3亿元,在线视频行业市场规 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLmE6Zz.html" rel="bookmark" class="title">数据安全争夺战：投资比例不足1&percnt; 网络安全产业爆发在即</a>
					<div>
						网络安全法正式实施14天,业内关于&lt;网络安全法&gt;的讨论层出不穷. 2017年中国云市场竞争中,&quot;1分中标&quot;.&quot;1元中标&quot;案例已经不新鲜,在竞争白热化 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxNOEb.html" rel="bookmark" class="title">项目-找工作 需要有C 或c&plus;&plus;的开发经验 怎么办</a>
					<div>
						问题描述 找工作 需要有C 或c++的开发经验 怎么办 本人是应届硕士,但是都是理论多 没动手实际开发过项目 ,主要是C语言的 但是公司都要求有开发经验,所以想自己上网学一个开发过程-- 因为从网上看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQnrVz.html" rel="bookmark" class="title">select-sql语句in的用法，在mybatis中sql中in是怎么用的</a>
					<div>
						问题描述 sql语句in的用法,在mybatis中sql中in是怎么用的 SELECT a.smid,a.smx,a.smy,a.NAME FROM BusPoint a , BusPointline ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn7eDAz.html" rel="bookmark" class="title">android-如何调试andriod中Activity中的代码？</a>
					<div>
						问题描述 如何调试andriod中Activity中的代码? 请问如何调试安卓中的Activity中的代码?楼主才接触安卓不久,请大神,大牛大拿帮帮哈. 在mainActivity中已经继承了Acti ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGEmoeM.html" rel="bookmark" class="title">vc-这个界面里的东西是什么意思啊？ VC6&period;0 按下F10的时候弹出来的</a>
					<div>
						问题描述 这个界面里的东西是什么意思啊? VC6.0 按下F10的时候弹出来的 左上角main( ) line4 这里 .这个窗口里的东西是什么意思 ?寄存器窗口?汇编窗口? 解决方案 这个窗口是al ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXm14z.html" rel="bookmark" class="title">framebuffer 输出尺寸和实际尺寸不一只</a>
					<div>
						问题描述 framebuffer 输出尺寸和实际尺寸不一只 各位高手,小弟头一次提问,见谅了,问题如下: 本人pc显示分辨率是1366*768,32位色,装的是ubuntu 12.04 内核版本是3. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAAoYnM.html" rel="bookmark" class="title">微软办公软件出现&OpenCurlyDoubleQuote;零日&rdquo;漏洞</a>
					<div>
						[新华社天津7月19日电](记者 张建新 高原)国家计算机病毒应急处理中心通过互联网络监测发现,微软公司的办公处理软件Office出现&quot;零日&quot;漏洞,互联网络中恶意攻击者已开始广泛进 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZjP6z.html" rel="bookmark" class="title">raphael绘制动态交互地图</a>
					<div>
						问题描述 raphael绘制动态交互地图 raphael绘制动态交互地图,用raphael绘制中国地图,然后想实现一个效果:点击某个区域,在这个区域上弹出一个柱状图,或者怎样用raphael来获取点击 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myee9ZM.html" rel="bookmark" class="title">我是如何从建站新鸟变成老鸟</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 我从事网站技术方面三年了,回想一下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Y08oz.html" rel="bookmark" class="title">Android 空指针异常怎么解决？</a>
					<div>
						问题描述 Android 空指针异常怎么解决? refreshableview.setOnRefreshListener(new PullToRefreshListener(){ @Override  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mgwr36M.html" rel="bookmark" class="title">36句经典英文格言</a>
					<div>
						1.Practice makes perfect.熟能生巧.2.God helps those who help themselves.天助自助者.3.Easier said than done.说起 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZVNkb.html" rel="bookmark" class="title">sqlserver not in 语句使程充崩溃&lowbar;MsSql</a>
					<div>
						两张表 组织架构表(Organise) 和 工资发放历史记录表 (WagePerMonthHis) 两张表通过 Organise.Item_id 和 WagePerMonthHis.OrgIdS 进行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3Zy2mz.html" rel="bookmark" class="title">Android软键盘挡住输入框的终极解决方案&lowbar;Android</a>
					<div>
						前言 开发做得久了,总免不了会遇到各种坑. 而在Android开发的路上,『软键盘挡住了输入框』这个坑,可谓是一个旷日持久的巨坑--来来来,我们慢慢看. 入门篇 最基本的情况,如图所示:在页面底部有一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx20Nyz.html" rel="bookmark" class="title">一个32位系统和64位系统的一个weblogic server 分别支持 最大的内存 和 最合理的并发量是多少</a>
					<div>
						问题描述 一个32位系统和64位系统的一个weblogicserver分别支持最大的内存和最合理的并发量是多少?有没有什么行业标准值呢?假如我的系统每天有好几万用户访问,设置多少个weblogicse ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
